Index: GTP/trunk/Lib/Vis/Preprocessing/src/common.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/common.h	(revision 1112)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/common.h	(revision 1145)
@@ -38,5 +38,5 @@
 //#pragma warning(disable:4244)
 
-#if 0 // $$$matt: comment this out because conflicts with definition in qt library!!
+#if 0 // Note matt: comment this out because conflicts with definition in qt library!!
 typedef unsigned int uint;
 #endif
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.h	(revision 1133)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.h	(revision 1145)
@@ -170,9 +170,11 @@
 		float mPriority;
 
-		VspBspSplitCandidate(): mPriority(0) 
+		float mRenderCostDecr;
+
+		VspBspSplitCandidate(): mPriority(0), mRenderCostDecr(0) 
 		{};
 
 		VspBspSplitCandidate(const Plane3 &plane, const VspBspTraversalData &tData): 
-		mSplitPlane(plane), mParentData(tData), mPriority(0)
+		mSplitPlane(plane), mParentData(tData), mPriority(0), mRenderCostDecr(0) 
 		{}
 
@@ -404,5 +406,5 @@
 	/** Evaluates candidate for splitting.
 	*/
-	void EvalSplitCandidate(VspBspTraversalData &tData, VspBspSplitCandidate &splitData);
+	void EvalSplitCandidate(VspBspSplitCandidate &splitData);
 
 	/** Computes priority of the traversal data and stores it in tData.
@@ -413,5 +415,6 @@
 	*/
 	float EvalRenderCostDecrease(const Plane3 &candidatePlane,
-								 const VspBspTraversalData &data) const;
+								 const VspBspTraversalData &data,
+								 float &normalizedOldRenderCost) const;
 
 	/** Constructs tree using the split priority queue.
@@ -705,4 +708,9 @@
 	//float GetMemUsage(const VspBspTraversalQueue &tstack) const;
 
+
+	void EvalSubdivisionStats(const VspBspTraversalData &tData,
+						      const VspBspTraversalData &tFrontData,
+							  const VspBspTraversalData &tBackData
+							  );
 
 	/** Adds stats to subdivision log file.
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h	(revision 1144)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h	(revision 1145)
@@ -66,7 +66,4 @@
 	int mMaxCostMisses;
 
-	/// priority of this split
-	//float mPriority;
-	
 	SplitCandidate()
 	{};
@@ -78,4 +75,22 @@
 	virtual int Type() const = 0;
 	virtual bool GlobalTerminationCriteriaMet() const = 0;
+
+	/** Set render cost decrease achieved through this split.
+	*/
+	void SetRenderCostDecrease(const float renderCostDecr)
+	{
+		mRenderCostDecrease = renderCostDecr;
+	}
+	
+	float GetRenderCostDecrease() const
+	{
+		return mRenderCostDecrease;
+	}
+
+protected:
+
+	/// render cost decrease achieved through this split
+	float mRenderCostDecrease;
+	
 };
 
@@ -814,5 +829,6 @@
 	*/
 	float EvalRenderCostDecrease(const AxisAlignedPlane &candidatePlane,
-								 const VspTraversalData &data) const;
+								 const VspTraversalData &data,
+								 float &normalizedOldRenderCost) const;
 
 	/** Collects view cells in the subtree under root.
@@ -852,5 +868,5 @@
 	*/
 	VspNode *Subdivide(SplitQueue &tQueue,
-					   VspSplitCandidate &splitCandidate,
+					   SplitCandidate *splitCandidate,
 					   const bool globalCriteriaMet);
 
@@ -859,5 +875,4 @@
 	void AddSubdivisionStats(const int viewCells,
 							 const float renderCostDecr,
-							 const float splitCandidateCost,
 							 const float totalRenderCost,
 							 const float avgRenderCost);
@@ -1024,5 +1039,9 @@
 		RayInfoContainer &rays);
 
+	void EvalSubdivisionStats(const VspTraversalData &tData,
+							  const VspTraversalData &tFrontData,
+							  const VspTraversalData &tBackData);
 protected:
+
 
 	bool mUseKdPvsForHeuristics;
@@ -1442,5 +1461,6 @@
 	*/
 	float EvalRenderCostDecrease(const AxisAlignedPlane &candidatePlane,
-								 const OspTraversalData &data) const;
+								 const OspTraversalData &data,
+								 float &normalizedOldRenderCost) const;
 
 
@@ -1463,5 +1483,5 @@
 	*/
 	KdNode *Subdivide(SplitQueue &tQueue,
-					  OspSplitCandidate &splitCandidate,
+					  SplitCandidate *splitCandidate,
 					  const bool globalCriteriaMet);
 	
@@ -1585,22 +1605,29 @@
 		@param rightPvs updates the right pvs
 	*/
-	void EvalHeuristicsContribution(const SortableEntry &ci,
+	void EvalHeuristicsContribution(KdLeaf *leaf,
+		const SortableEntry &ci,
 		float &volLeft,
 		float &volRight,
 		int &pvsLeft,
-		int &pvsRight);
+		int &pvsRight,
+		int &viewCellsLeft,
+		int &viewCellsRight);
 
 	/** Evaluate the contributions of view cell volume of the left and the right view cell.
 	*/
-	void EvalVolumeContribution(const VssRay &ray, float &volLeft, float &volRight);
+	void EvalVolumeContribution(const VssRay &ray, 
+								float &volLeft, 
+								float &volRight,
+								int &viewCellsLeft,
+								int &viewCellsRight);
 
 	/** Prepares objects for the cost heuristics.
 		@returns pvs size of the node
 	*/
-	float PrepareHeuristics(const OspTraversalData &tData);
+	float PrepareHeuristics(const OspTraversalData &tData, int &numViewCells);
 
 	/** Prepares heuristics for a particular ray.
 	*/
-	float PrepareHeuristics(const VssRay &ray);
+	float PrepareHeuristics(const VssRay &ray, int &numViewCells);
 
 	/** Prepares construction for vsp and osp trees.
@@ -1620,6 +1647,20 @@
 		RayInfoContainer &rays);
 
-
+	/** Reads parameters from environment singleton.
+	*/
 	void ReadEnvironment();
+
+	/** Returns true if the specified ray end points is inside the kd leaf.
+		@param isTermination if origin or termination point should be checked
+	*/
+	bool EndPointInsideNode(KdLeaf *leaf, VssRay &ray, bool isTermination) const;
+
+	void AddViewCellVolume(ViewCell *vc,
+						   const int cf,
+						   float &frontPvs,
+						   float &backPvs,
+						   float &totalPvs) const;
+
+	int ClassifyRay(VssRay *ray, KdLeaf *leaf, const AxisAlignedPlane &plane) const;
 
 protected:
@@ -1779,5 +1820,8 @@
 		RayInfoContainer &objectSpaceRays);
 
-	bool FinishedConstruction();
+	void RunConstruction(const bool repair);
+	bool SubdivideSplitCandidate(SplitCandidate *sc);
+
+	bool FinishedConstruction() const;
 
 	SplitCandidate *NextSplitCandidate();
@@ -1787,9 +1831,9 @@
 	void CollectDirtyCandidates(vector<SplitCandidate *> &dirtyList);
 
-	SplitCandidate *PrepareVsp(const VssRayContainer &sampleRays,
+	VspTree::VspSplitCandidate *PrepareVsp(const VssRayContainer &sampleRays,
 							   AxisAlignedBox3 *forcedViewSpace,
 							   RayInfoContainer &rays);
 
-	SplitCandidate *PrepareOsp(const VssRayContainer &sampleRays,
+	OspTree::OspSplitCandidate *PrepareOsp(const VssRayContainer &sampleRays,
 		const ObjectContainer &objects,
 		AxisAlignedBox3 *forcedObjectSpace,
Index: GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.h	(revision 860)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.h	(revision 1145)
@@ -1,6 +1,6 @@
 #ifndef __PREPROCESSOR_THREAD_H
 #define __PREPROCESSOR_THREAD_H
-
-#include <QThread>
+// matt: remove qt dependencies
+//#include <QThread>
 
 namespace GtpVisibilityPreprocessor {
@@ -8,19 +8,24 @@
 class Preprocessor;
 
-class PreprocessorThread : public QThread
+/** This class represents a preprocessor thread.
+*/
+class PreprocessorThread//: public QThread
 {
-  Q_OBJECT
+  //Q_OBJECT
 
   Preprocessor *mPreprocessor;
 public:
-  PreprocessorThread(Preprocessor *p, QObject *parent = 0);
+  //PreprocessorThread(Preprocessor *p, QObject *parent = 0);
+	PreprocessorThread(Preprocessor *p);
   ~PreprocessorThread();
+
+  void operator()();
 
   void Main();
 
-protected:
+/*protected:
   void run() {
 	Main();
-  }
+  }*/
 };
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp	(revision 1112)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp	(revision 1145)
@@ -2086,5 +2086,5 @@
 	//	exporter->ExportKdTree(*mKdTree);
 	exporter->SetWireframe();
-	exporter->ExportScene(preprocessor->mSceneGraph->mRoot);
+//	exporter->ExportScene(preprocessor->mSceneGraph->mRoot);
 	exporter->SetWireframe();
 	exporter->ExportBox(box);
Index: GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1112)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1145)
@@ -16,6 +16,8 @@
 #include "ResourceManager.h"
 
-#include <QApplication>
-#include <QtOpenGL>
+//#include <QApplication>
+//#include <QtOpenGL>
+#include <boost/thread/thread.hpp>
+#include <boost/thread/xtime.hpp>
 #include "GlRenderer.h"
 
@@ -25,4 +27,62 @@
 
 using namespace GtpVisibilityPreprocessor;
+
+Preprocessor *preprocessor = NULL;
+
+#if QT_ENABLED
+QApplication *app = NULL;
+#endif
+
+
+void Cleanup()
+{
+#if QT_ENABLED
+	DEL_PTR(rendererWidget);
+#endif
+
+	DEL_PTR(preprocessor);
+
+	Environment::DelSingleton();
+	MeshManager::DelSingleton();
+	MaterialManager::DelSingleton();
+}
+
+
+void DisplayWidget()
+{
+#if QT_ENABLED
+	QApplication *app = NULL;
+
+	// create a qt application first (must be created before any opengl widget ...)
+	app = new QApplication(argc, argv);
+
+	if (!QGLFormat::hasOpenGL() || !QGLPixelBuffer::hasOpenGLPbuffers()) {
+		QMessageBox::information(0, "OpenGL pbuffers", 
+			"This system does not support OpenGL/pbuffers.",
+			QMessageBox::Ok);
+		return -1;
+	}
+	
+	// note matt: capsulate qt dependent code as good as possible
+	rendererWidget = 
+		new GlRendererWidget(p->mSceneGraph, p->mViewCellsManager, p->mKdTree);
+
+	rendererWidget->resize(640, 480);
+	rendererWidget->show();
+
+	if (0 && p->GetRenderer()) 
+	{
+		cout<<"CONNECTING"<<endl;
+		QObject::connect(p->GetRenderer(),
+		SIGNAL(UpdatePvsErrorItem(int i, GlRendererBuffer::PvsErrorEntry &)),
+				rendererWidget->mControlWidget, 
+				SLOT(UpdatePvsErrorItem(int i,
+				GlRendererBuffer::PvsErrorEntry &)));
+
+		cout<<"CONNECTED"<<endl;
+	}
+#endif
+}
+
 
 int
@@ -30,153 +90,118 @@
 {
 
-  //Now just call this function at the start of your program and if you're
-  //compiling in debug mode (F5), any leaks will be displayed in the Output
-  //window when the program shuts down. If you're not in debug mode this will
-  //be ignored. Use it as you will!
-  //note: from GDNet Direct [3.8.04 - 3.14.04] void detectMemoryLeaks() {
-  _CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF|_CRTDBG_ALLOC_MEM_DF);
-  _CrtSetReportMode(_CRT_ASSERT,_CRTDBG_MODE_FILE);
-  _CrtSetReportFile(_CRT_ASSERT,_CRTDBG_FILE_STDERR); 
-
-  InitTiming();
-
-  Debug.open("debug.log");
-  
-  Environment::GetSingleton()->Parse(argc, argv, USE_EXE_PATH);
-  MeshKdTree::ParseEnvironment();
-
-  char buff[128];
-  Environment::GetSingleton()->GetStringValue("Preprocessor.type", buff);
-  string preprocessorType(buff);
-
-  Preprocessor *p = NULL;
-
- 
-  if (preprocessorType == "vss")
-  {
-	  p = new VssPreprocessor();
-  }
-  else
-  {
-	if (preprocessorType == "rss")
-	{
-		p = new RssPreprocessor();
+	//Now just call this function at the start of your program and if you're
+	//compiling in debug mode (F5), any leaks will be displayed in the Output
+	//window when the program shuts down. If you're not in debug mode this will
+	//be ignored. Use it as you will!
+	//note: from GDNet Direct [3.8.04 - 3.14.04] void detectMemoryLeaks() {
+	_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF|_CRTDBG_ALLOC_MEM_DF);
+	_CrtSetReportMode(_CRT_ASSERT,_CRTDBG_MODE_FILE);
+	_CrtSetReportFile(_CRT_ASSERT,_CRTDBG_FILE_STDERR); 
+
+	int returnCode = 0;
+
+	InitTiming();
+
+	Debug.open("debug.log");
+
+	Environment::GetSingleton()->Parse(argc, argv, USE_EXE_PATH);
+	MeshKdTree::ParseEnvironment();
+
+	char buff[128];
+	Environment::GetSingleton()->GetStringValue("Preprocessor.type", buff);
+	string preprocessorType(buff);
+
+	if (preprocessorType == "vss")
+	{
+		preprocessor = new VssPreprocessor();
 	}
 	else
 	{
-	  if (preprocessorType == "exact")
-	  {
-		p = new ExactPreprocessor();
-	  }
-	  else
-	  {
-		if (preprocessorType == "sampling")
+		if (preprocessorType == "rss")
 		{
-		  p = new SamplingPreprocessor();
+			preprocessor = new RssPreprocessor();
 		}
 		else
-		{	
-		  if (preprocessorType == "render")
-		  {
-			 p = new RenderSampler();
-		  }
-		  else {
-			  Environment::DelSingleton();
-			  cerr<<"Unknown preprocessor type"<<endl;
-			  Debug<<"Unknown preprocessor type"<<endl;
-			  exit(1);
-		  }
+		{
+			if (preprocessorType == "exact")
+			{
+				preprocessor = new ExactPreprocessor();
+			}
+			else
+			{
+				if (preprocessorType == "sampling")
+				{
+					preprocessor = new SamplingPreprocessor();
+				}
+				else
+				{	
+					if (preprocessorType == "render")
+					{
+						preprocessor = new RenderSampler();
+					}
+					else {
+						Environment::DelSingleton();
+						cerr<<"Unknown preprocessor type"<<endl;
+						Debug<<"Unknown preprocessor type"<<endl;
+						exit(1);
+					}
+				}
+			}
 		}
-	  }
-	}
-  }
-  
-  QApplication *app = NULL;
-
-  if (p->mUseGlRenderer || p->mUseGlDebugger) {
+	}
 	
-	// create a qt application first (must be created before any opengl widget...
-	app = new QApplication(argc, argv);
-	
-	if (!QGLFormat::hasOpenGL() || !QGLPixelBuffer::hasOpenGLPbuffers()) {
-	  QMessageBox::information(0, "OpenGL pbuffers", 
-							   "This system does not support OpenGL/pbuffers.",
-							   QMessageBox::Ok);
-	  return -1;
-	}
-  }
-  
-  preprocessor = p;
-  
-  Environment::GetSingleton()->GetStringValue("Scene.filename", buff);
-  string filename(buff);
- 
-  p->LoadScene(filename);
-  
-  p->BuildKdTree();
-  p->KdTreeStatistics(cout);
- 
-  // parse view cells related options
-  p->PrepareViewCells();
-  
-
-  // create a preprocessor thread
-  PreprocessorThread *pt = new PreprocessorThread(p, app);
-
-  //  p->mSceneGraph->Export("soda.x3d");
-  if (0) {
-    p->Export(filename + "-out.x3d", true, false, false);
-    p->Export(filename + "-kdtree.x3d", false, true, false);	
-  }
-
-  if (p->mUseGlRenderer) {
-	 
-	rendererWidget = new GlRendererWidget(p->mSceneGraph, p->mViewCellsManager, p->mKdTree);
-	//  renderer->resize(640, 480);
-	 
-	rendererWidget->resize(640, 480);
-	rendererWidget->show();
-	
-	if (0 && p->GetRenderer()) {
-	  
-	  cout<<"CONNECTING"<<endl;
-	  QObject::connect(p->GetRenderer(),
-					   SIGNAL(UpdatePvsErrorItem(int i,
-												 GlRendererBuffer::PvsErrorEntry &)),
-					   
-					   rendererWidget->mControlWidget,
-					   SLOT(UpdatePvsErrorItem(int i,
-											   GlRendererBuffer::PvsErrorEntry &)));
-	  cout<<"CONNECTED"<<endl;
-	}
-	
-	pt->start(QThread::LowPriority);
-	
-	
-  } else{
-	// just call the mail method -> will be executed in the main thread
-	pt->Main();
-  }
-  
-
-  int returnCode = 0;
-
-  if (app)
-  {
-	 returnCode = app->exec();
-	DEL_PTR(app);
-	}
-
-  //-- clean up
-  DEL_PTR(p);
-  Environment::DelSingleton();
-  DEL_PTR(rendererWidget);
-
-  MeshManager::DelSingleton();
-  MaterialManager::DelSingleton();
-
-  DEL_PTR(pt);
-
-  return returnCode;
+
+	//-- load scene 
+
+	Environment::GetSingleton()->GetStringValue("Scene.filename", buff);
+	string filename(buff);
+	preprocessor->LoadScene(filename);
+
+	//-- build kd tree from scene geometry
+
+	preprocessor->BuildKdTree();
+	preprocessor->KdTreeStatistics(cout);
+
+	// parse view cells related options
+	preprocessor->PrepareViewCells();
+
+	//  p->mSceneGraph->Export("soda.x3d");
+	if (0) {
+		preprocessor->Export(filename + "-out.x3d", true, false, false);
+		preprocessor->Export(filename + "-kdtree.x3d", false, true, false);	
+	}
+
+
+	// create a preprocessor thread
+	//PreprocessorThread *pt = new PreprocessorThread(p, app);
+	PreprocessorThread pt(preprocessor);
+
+	if (preprocessor->mUseGlRenderer || preprocessor->mUseGlDebugger)
+	{
+		// display the render widget
+		DisplayWidget();
+
+		// create and run the thread
+		boost::thread thrd(pt);
+		thrd.join();
+		//pt->start(QThread::LowPriority);
+	} 
+	else
+	{
+		// just call the mail method -> will be executed in the main thread
+		pt.Main();
+	}
+
+#if QT_ENABLED
+	if (app)
+	{
+		returnCode = app->exec();
+        DEL_PTR(app);
+	}
+#endif
+
+	Cleanup();
+
+	return returnCode;
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h	(revision 1008)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h	(revision 1145)
@@ -3,8 +3,10 @@
 
 //#include "glInterface.h"
-#include <QtOpenGL>
-#include <QWaitCondition>
-
+
+//#include <QWaitCondition>
+//#include <QtOpenGL>
 //#include <QGLPixelBuffer>
+
+//class QWidget;
 
 #include "Vector3.h"
@@ -14,5 +16,4 @@
 #include "Beam.h"
 
-class QWidget;
 
 namespace GtpVisibilityPreprocessor {
@@ -105,9 +106,9 @@
   bool mUseGlLists;
   
-  QString mSnapPrefix;
+  string mSnapPrefix;
 
   KdTree *mKdTree;
 
-  QWaitCondition mRenderingFinished;
+  //QWaitCondition mRenderingFinished;
   
   vector<OcclusionQuery *> mOcclusionQueries;
@@ -117,5 +118,5 @@
 			 KdTree *tree);
   
-  ~GlRenderer();
+  virtual ~GlRenderer();
 
 
@@ -151,11 +152,10 @@
 
 
-class GlRendererBuffer : public QObject, public QGLPixelBuffer, public GlRenderer
+class GlRendererBuffer: public GlRenderer
 {
-Q_OBJECT
+
+//Q_OBJECT
 public:
-GlRendererBuffer(const int w,
-				 const int h,
-				 SceneGraph *sceneGraph,
+GlRendererBuffer(SceneGraph *sceneGraph,
 				 ViewCellsManager *viewcells,
 				 KdTree *tree);
@@ -182,16 +182,16 @@
 						  vector<RenderCostSample> &samples,
 						  const bool useOcclusionQueries,
-						  const int threshold = 0);
-
-
-  void
-  EvalPvsStat();
-
-  void
-  ClearErrorBuffer();
-  
-
-  virtual int GetWidth() const { return width(); }
-  virtual int GetHeight() const { return height(); }
+						  const int threshold = 0)
+	{}
+
+	/** Implerment in subclasses.
+	*/
+	void EvalPvsStat() {};
+
+	void ClearErrorBuffer();
+  
+
+  virtual int GetWidth() const { return 0; }
+  virtual int GetHeight() const { return 0; }
 
 
@@ -230,9 +230,9 @@
   int mPvsStatFrames;
   struct PvsErrorEntry {
-	PvsErrorEntry() {}
-	float mError;
-	int mPvsSize;
-	Vector3 mPosition;
-	Vector3 mDirection;
+	  PvsErrorEntry() {}
+	  float mError;
+	  int mPvsSize;
+	  Vector3 mPosition;
+	  Vector3 mDirection;
   };
   
@@ -240,6 +240,6 @@
 
   
-private:
-  unsigned int *mPixelBuffer;
+protected:
+	unsigned int *mPixelBuffer;
   
 	static void GenQueries(const int numQueries);
@@ -258,219 +258,8 @@
 
 public:
-  signals:
-	void UpdatePvsErrorItem(int i, GlRendererBuffer::PvsErrorEntry &);
-};
-
-
-class RendererControlWidget : public QWidget
-{
-  Q_OBJECT
-public:
-
-  QListWidget *mPvsErrorWidget;
-
-  RendererControlWidget(QWidget * parent = 0, Qt::WFlags f = 0);
-
-  public slots:
-
-  void FocusNextPvsErrorFrame();
-  void UpdatePvsErrorItem(int i,
-						  GlRendererBuffer::PvsErrorEntry &);
-
-  signals:
-  
-  void SetViewCellGranularity(int);
-  void SetSceneCut(int);
-  void SetTopDistance(int);
-  void SetVisibilityFilterSize(int);
-  void SetSpatialFilterSize(int);
-
-  void SetRenderFilter(bool);
-  void SetUseFilter(bool);
-  void SetUseSpatialFilter(bool);
-  void SetRenderErrors(bool);
-  void SetShowViewCells(bool);
-  void SetShowRenderCost(bool);
-  void SetShowPvsSizes(bool);
-  void SetTopView(bool);
-  void SetCutViewCells(bool);
-  void SetCutScene(bool);
-
-  
-};
-
-class GlRendererWidget : public QGLWidget, public GlRenderer
-{
-  Q_OBJECT
-public:
-
-  // point of the last mouse click used for movement in the scene
-  Vector3 mousePoint;
-
-  bool mTopView;
-  bool mRenderViewCells;
-  bool mCutViewCells;
-  bool mCutScene;
-  bool mRenderErrors;
-  bool mRenderFilter;
-  bool mUseFilter;
-  bool mUseSpatialFilter;
-  bool mShowRenderCost;
-  
-  bool mShowPvsSizes;
-  float mSpatialFilterSize;
-  
-  Plane3 mSceneCutPlane;
-  float mTopDistance;
-
-  // some statistics
-  int mPvsSize;
-  float mRenderError;
-
-  RendererControlWidget *mControlWidget;
-  
-  GlRendererWidget(SceneGraph *sceneGraph,
-				   ViewCellsManager *viewcells,
-				   KdTree *tree,
-				   QWidget * parent = 0, const QGLWidget * shareWidget = 0, Qt::WFlags f = 0
-				   );
-
-
-  virtual void SetupCamera();
-
-  void initializeGL() {
-	InitGL();
-  }
-  void resizeGL(int w, int h);
-  void paintGL();
-  void timerEvent(QTimerEvent *) {
-	  update();
-  }
-
-  void mousePressEvent(QMouseEvent *);
-  void mouseReleaseEvent(QMouseEvent *);
-  void mouseMoveEvent(QMouseEvent *);
-
-  void keyPressEvent ( QKeyEvent * e ) ;
-
-  void
-  RenderPvs();
-
-  float
-  RenderErrors();
-  void
-  RenderInfo();
-
-  virtual int GetWidth() const { return width(); }
-  virtual int GetHeight() const { return height(); }
-
- virtual void
-  SetupProjection(const int w, const int h, const float angle = 70.0f);
-
-  void
-  RenderViewCells();
-
- public slots:
-
- void SetRenderErrors(bool b) {
-   mRenderErrors = b;
-   updateGL();
- }
-
- void SetRenderFilter(bool b) {
-   mRenderFilter = b;
-   updateGL();
- }
-
-  void SetUseFilter(bool b) {
-   mUseFilter = b;
-   updateGL();
- }
-
-  void SetUseSpatialFilter(bool b) {
-	mUseSpatialFilter = b;
-	updateGL();
-  }
-
-  
-  void
-  SetViewCellGranularity(int number);
-  
-  void
-  SetVisibilityFilterSize(int number);
-
-  void
-  SetSpatialFilterSize(int number);
-  
-  void
-  SetSceneCut(int cut);
-  
-  void
-  SetTopDistance(int dist);
-  
-  void SetShowViewCells(bool b) {
-	mRenderViewCells = b;
-	updateGL();
-  }
-
-  void SetShowRenderCost(bool b) {
-	mShowRenderCost = b;
-	updateGL();
-  }
-
-  void SetShowPvsSizes(bool b) {
-	mShowPvsSizes = b;
-	updateGL();
-  }
-
-  void SetTopView(bool b) {
-	mTopView = b;
-	updateGL();
-  }
-
-  void SetCutViewCells(bool b) {
-	mCutViewCells = b;
-	updateGL();
-  }
-  void SetCutScene(bool b) {
-	mCutScene = b;
-	updateGL();
-  }
-
-
-};
-
-
-extern GlRendererWidget *rendererWidget;
-
-class GlDebuggerWidget : public QGLWidget
-{
-	Q_OBJECT
-public:
-    GlDebuggerWidget(GlRendererBuffer *buf, QWidget *parent = NULL);
-    ~GlDebuggerWidget();
-    void initializeGL();
-    void resizeGL(int w, int h);
-    void paintGL();
-    void timerEvent(QTimerEvent *) { update(); }
-    void mousePressEvent(QMouseEvent *) { killTimer(timerId); }
-    void mouseReleaseEvent(QMouseEvent *) { timerId = startTimer(20); }
-
-    void initCommon();
-    void initPbuffer();
-
-  
-	 GlRendererBuffer *mRenderBuffer;
-
-	 Beam mBeam;
-	 int mSamples;
-	 Intersectable *mSourceObject;
-
-private:
-    GLuint dynamicTexture;
-    int timerId;
-};
-
-extern GlDebuggerWidget *debuggerWidget;
+	// matt: remove qt dependencies
+ // signals:
+//	void UpdatePvsErrorItem(int i, GlRendererBuffer::PvsErrorEntry &);
+};
 
 };
